/*
 * DynamicCore.hh
 */
#ifndef __DynamicCore_hh__
#define __DynamicCore_hh__

#include "CoreAllocator.hh"

class DynamicCore : public CoreAllocator {
	// constants
	const static float CPU_HZ = 2.4e9;	// /proc/cpuinfo defines CPU frequency
#ifndef CPU_NO
	const static int CPU_NO = 6;			// count the number of CPUs dedicated to VR instances
#endif
	const static int VRI_RATE_MAX = 1e5;	// if the throughput is above this threshold, create a VR instance adapter

	// data member
	__u64 timeStamp;
	VRInstanceMonitor* cpuToVR[CPU_NO];	// map CPUs to VRs

	__u64 getTimeStamp();	//save hardware TimeStamp Counter to Destination Register
	void allocate();

public:
	DynamicCore(VRInstanceMonitor***, int*);
};

#endif
