/*
 * UniCore.cc
 * - Core allocator
 */
#include "FixCore.hh"

/*
 * Constructor
 */
FixCore::FixCore(VRInstanceMonitor*** vrInstanceMonitor_par, int* vrInstanceMonitorCount_par) {	// get the LVRM dispatched
	vrInstanceMonitor = vrInstanceMonitor_par;
	vrInstanceMonitorCount = vrInstanceMonitorCount_par;
}

/*
 * Re-allocate the processor cores
 */
void FixCore::allocate() {
	const int CPU[] = {2, 6, 1, 3, 5, 7, 4};

	if (!(*vrInstanceMonitor)[0]->getVRInstanceAdapterCount()) {
		for (int i = 0; i < CPU_NO; i++) {
			(*vrInstanceMonitor)[0]->createVRInstanceAdapter(CPU[i % 7]);
		}

#ifdef PRINT_END
		sleep(1);
#endif
	}
}
