/*
 * jsq.cc
 * - Join-the-Shortest-Queue
 */
#include "jsq.hh"

/*
 * Constructor
 */
jsq::jsq(int* vrInstanceAdapterCount_par, VRInstanceAdapter*** vrInstanceAdapter_par) {	// initalize the dispatcher
	vrInstanceAdapter = vrInstanceAdapter_par;
	vrInstanceAdapterCount = vrInstanceAdapterCount_par;
}

/*
 * Balance the load
 */
int jsq::balance() {
	int currentQLoad, sqID = 0, sqLoad = INT_MAX;	// initialize some variables for the selection of the shortest queue

	for (int i = 0; i < *vrInstanceAdapterCount; i++) {	// linear search for the shortest queue
		if ((currentQLoad = (*vrInstanceAdapter)[i]->latencyEstimator->estimate()) < sqLoad) {
			sqLoad = currentQLoad;
			sqID = i;
		}
	}

	return sqID;	// return the ID of the shortest queue to be joined
}
