/*
 * ArrivalTime.cc
 * - estimate the throughput by the arrival rate
 */
#include "ArrivalTime.hh"

/*
 * Constructor
 */
ArrivalTime::ArrivalTime() : timeStamp(getTimeStamp()) {	// initialize the time-stamp
}

/*
 * Calculate the estimate
 */
float ArrivalTime::estimate() {	// calculate the the difference from the current arrival to the previous arrival
	__u64 timeStamp_ = timeStamp;
	return arrivalTime = (timeStamp = getTimeStamp()) - timeStamp_;
}

/*
 * Get the previous estimate without re-calculate
 */
float ArrivalTime::getEstimate() {	// access the arrival time
	return arrivalTime;
}

/*
 * Get the time-stamp counter
 */
__u64 ArrivalTime::getTimeStamp() {	//save hardware TimeStamp Counter to Destination Register
	__u32 hi, lo;
	asm volatile("rdtsc" : "=d" (hi), "=a" (lo));
	return (__u64) hi << 32 | lo;
}
