/*
 * QueueLength.cc
 * - estimate the latency by the queue length of ring buffer
 */
#include "../VRInstanceAdapter/VRInstanceAdapter.hh"
#include "QueueLength.hh"

/*
 * Constructor
 */
QueueLength::QueueLength(VRInstanceAdapter* vrInstanceAdapter) : vrInstanceAdapter(vrInstanceAdapter) {	// initialize the VR instance
}

/*
 * Calculate the estimate
 */
float QueueLength::estimate() {	// estimate by the queue length of the data ring buffer to the VR instance
	return ((VRInstanceAdapter*) vrInstanceAdapter)->ipcBuffer[VRInstanceAdapter::DATA_TO_VR_INSTANCE]->dataCount();
}

/*
 * Return the estimate
 */
float QueueLength::getEstimate() {	// wrap estimate()
	return estimate();
}
