/*
 * WeightedQueueLength.cc
 * - estimate the latency by the queue length of ring buffer
 */
#include "../VRInstanceAdapter/VRInstanceAdapter.hh"
#include "WeightedQueueLength.hh"

/*
 * Constructor
 */
WeightedQueueLength::WeightedQueueLength(VRInstanceAdapter* vrInstanceAdapter) : vrInstanceAdapter(vrInstanceAdapter) {
}	// initialize the VR instance

/*
 * Calculate the estimate
 */
float WeightedQueueLength::estimate() {	// estimate by the queue length of the data ring buffer to the VR instance
	float currentEstimate = ((VRInstanceAdapter*) vrInstanceAdapter)->ipcBuffer[VRInstanceAdapter::DATA_TO_VR_INSTANCE]->dataCount();
	return weightedEstimate = (currentEstimate + weight * weightedEstimate) / (1 + weight);
}

/*
 * Return the estimate
 */
float WeightedQueueLength::getEstimate() {	// wrap estimate()
	return weightedEstimate;
}
