/*
 * PCapFile.hh
 */

#ifndef __PCapFile_hh__
#define __PCapFile_hh__

#include <linux/if_ether.h>
#include <pcap.h>
#include <signal.h>
#include <stdlib.h>
#include "SocketAdapter.hh"

class PCapFile : public SocketAdapter {
	// constants
	const static float CPU_HZ = 2393.885e6;	// /proc/cpuinfo defines CPU frequency
	const static int PKT_NO = 1e8;			// number of packets to be read from the PCap file to the RAM as the data soruce

	// data members
	char *pCurrent;		// pointer to the current network frame
	__u64 timeStamp[2];	// timestamps of the start and the end

	__u64 getTimeStamp();
	int fromLVRM(char*, int);
	int toLVRM(char*);

public:
	PCapFile();
	void end();
	void start();
};

#endif
