#ifndef CLICK_FROMLVRM_HH
#define CLICK_FROMLVRM_HH
#include <asm/types.h>
#include <click/element.hh>
#include <click/task.hh>
#include "FourRingBuffers.hh"
#define LVRM_ADAPTER FourRingBuffers
CLICK_DECLS

class FromLVRM : public Element {
	int shmid; // shared memeory identifier
	LVRMAdapter* lvrmAdapter;
	Task task;
	__u64 n, ts;
	long double t;

public:
	FromLVRM();
	const char* class_name() const { return "FromLVRM"; }

	const char* port_count() const {
		return "-";
	}

	const char* processing() const {
		return PUSH;
	}

	int configure(Vector<String>&, ErrorHandler*);
	int initialize(ErrorHandler*);
	bool run_task(Task*);
};

CLICK_ENDDECLS
#endif
