#include <click/config.h>
#include <click/confparse.hh>
#include <click/standard/scheduleinfo.hh>
#include "toLVRM.hh"
CLICK_DECLS

ToLVRM::ToLVRM() : task(this) {
}

int ToLVRM::configure(Vector<String>& conf, ErrorHandler* errh) {
	if (cp_va_parse(conf, this, errh, cpUnsigned, "SHMID", &shmid, cpEnd) < 0) {
		return -1;
	}

	return 0;
}

int ToLVRM::initialize(ErrorHandler* errh) {
	lvrmAdapter = new LVRM_ADAPTER(shmid);
	ScheduleInfo::initialize_task(this, &task, true, errh);
	return 0;
}

bool ToLVRM::run_task(Task*) {
	Packet* p = input(0).pull();

	if (p) {
		lvrmAdapter->toLVRM((char*) p->data(), p->length(), 0);
		p->kill();
	}

	task.fast_reschedule();
	return 0;
}

CLICK_ENDDECLS
EXPORT_ELEMENT(ToLVRM)
ELEMENT_MT_SAFE(ToLVRM)
