#ifndef CLICK_TOLVRM_HH
#define CLICK_TOLVRM_HH
#include <click/element.hh>
#include <click/task.hh>
#include "FourRingBuffers.hh"
#define LVRM_ADAPTER FourRingBuffers
CLICK_DECLS

class ToLVRM : public Element {
	int shmid; // shared memory identifier for initializing
	LVRMAdapter* lvrmAdapter;
	Task task;

public:
	ToLVRM();
	const char* class_name() const { return "ToLVRM"; }

	const char* port_count() const {
		return "-";
	}

	const char* processing() const {
		return PULL;
	}

	int configure(Vector<String>&, ErrorHandler*);
	int initialize(ErrorHandler*);
	bool run_task(Task*);
};

CLICK_ENDDECLS
#endif
