/*
 * LVRMAdapter.cc
 * - Connect to VLRM
 */

#include "LVRMAdapter.hh"

/*
 * Destructor
 */
LVRMAdapter::~LVRMAdapter() {
	shmdt(shmaddr);					// DeTach SHared Memory segment located at address specified by RING buf from address space
	shmctl(shmid, IPC_RMID, NULL);	// mark segment to be destroyed
}

/*
 * Get the time-stamp counter
 */
__u64 LVRMAdapter::getTimeStamp() {	// save hardware TimeStamp Counter to Destination Register
	__u32 hi, lo;	// the higher and the lower 32-bits of the 64-bit timestamp
	asm volatile("rdtsc" : "=d" (hi), "=a" (lo));
	return (__u64) hi << 32 | lo;
}
