#ifndef __LVRMAdapter_hh__ // VR instance API
#define __LVRMAdapter_hh__

#include <linux/if_ether.h>
#include <sys/shm.h>
#include "../IPCBuffer/BusyRingBuffer.hh"

class LVRMAdapter {
protected:
	// data members
	char* shmaddr;	// address attached
	int shmid;		// shared memory segment ID

	~LVRMAdapter();

public:
	// constants
	const static float CPU_HZ = 2393.885e6;			// /proc/cpuinfo defines CPU frequency
	const static int DATA_TO_VR_INSTANCE = 0;		// index of the data ring buffer from the VLRM to the VR instance
	const static int DATA_TO_LVRM = 1 ;				// index of the data ring buffer from the VR instance to the LVRM
	const static long SHM_ADDR = 0x700000000000;	// address tried to be attached

	// type definition
	struct Buffer {
		__u8 sd;					// source/destination instance
		char buffer[ETH_FRAME_LEN];	// ethernet frame buffer
	} __attribute((packed));

	__u64 getTimeStamp();
	virtual int fromLVRM(Buffer *buf) = 0;
	virtual int toLVRM(char*, int, __u8) = 0;
};

#endif
