#ifndef __MultiQueue_hh__ // VR instance API
#define __MultiQueue_hh__

#include "LVRMAdapter.hh"

class MultiQueue : public LVRMAdapter {
	// constants
	const static int CTRL_TO_VR_INSTANCE = 2;	// index of the IPC buffer for the control messages from the LVRM to the VR instance
	const static int CTRL_TO_LVRM = 3;			// index of the IPC buffer for the control messages from the VR instance to the LVRM
	const static int SHMMAX = 33554432;			// max seg size

	// data member
	RingBuffer<LVRMAdapter::Buffer>* ipcBuffer[4];	// IPC buffers

	int fromLVRM(LVRMAdapter::Buffer*);
	int toLVRM(char*, int, __u8);

public:
	MultiQueue(int);
};

#endif
