#include <linux/ip.h>
#include <stdlib.h>
#include <unistd.h>
#include "MultiQueue.hh"

int main(int, char** argv) {
	struct {								// forwarding information base
		__be32 daddr;						// destination IP address
		unsigned char h_dest[ETH_ALEN];		// destination MAC address
		unsigned char h_source[ETH_ALEN];	// source MAC address
	} __attribute((packed)) routeTable[] = {
		{0x1465A8C0, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1}},	// proj20
		{0x1565A8C0, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 2}},	// proj21
		{0x1666A8C0, {0, 0, 0, 0, 0, 3}, {0, 0, 0, 0, 0, 4}},	// proj22
		{0x1766A8C0, {0, 0, 0, 0, 0, 3}, {0, 0, 0, 0, 0, 5}},	// proj23
		{0}};													// 0-terminated

	LVRMAdapter::Buffer buffer;	// initialize some variables for the main loop
	const ethhdr* eth = (ethhdr*) ((char*) &buffer + sizeof buffer.sd /*+ sizeof buffer.timeStamp*/);
	const iphdr* ip = (iphdr*) ((char*) eth + ETH_HLEN);
	int len, send = 1;
	LVRMAdapter* lvrmAdapter = new MultiQueue(atoi(argv[1] + 6));
	__u64 timeStamp = 0;

	while (1) {	// main loop routes IP packets with repective to destination MAC address
		if (send && 1 < (lvrmAdapter->getTimeStamp() - timeStamp) / lvrmAdapter->CPU_HZ) {
			timeStamp = lvrmAdapter->getTimeStamp();
			*(__u64*) eth = timeStamp;
			lvrmAdapter->toLVRM((char*) eth, sizeof(__u64), 1);
		} else if (0 < (len = lvrmAdapter->fromLVRM(&buffer))) {
			if (buffer.sd) {
				printf("%f\n", (lvrmAdapter->getTimeStamp() - *(__u64*) eth) / lvrmAdapter->CPU_HZ);
				send = 0;
			} else if ((eth->h_proto == 8)) {
				for (int i = 0; routeTable[i].daddr; i++) {
					if (ip->daddr == routeTable[i].daddr) {
						memcpy((void*) eth, routeTable[i].h_dest, 2 * ETH_ALEN);
						lvrmAdapter->toLVRM((char*) eth, len, 0);
						break;
					}
				}
			}
		}
	}
}
