/*
 * Main program
 */
#include "LVRM.hh"
LVRM* lvrm;	// "VLRM.hh" extern lvrm

int main(int argc, char **argv) {
	if (argc < 3) {	// Usage checking
		return printf("%s VRName mapFile [2ndVRName2 2ndMapFile2] ...\n", argv[0]);
	}

	lvrm = new LVRM();	// allow dynamic LVRM allocation on heap & then initialize LVRM with VR instance monitor
	lvrm->initialize();

	for (int i = 1; i < argc; i += 2) {	// open & read map files' IP networks
		FILE* stream = fopen(argv[i + 1], "r");
		int keyCount, rtn = fscanf(stream, "%d", &keyCount);
		LVRM::KeyToVRIM keyToVRIM[keyCount];

		for (int j = 0; j < keyCount; j++) {	// read the IP networks after IP network count read
			int tmp;

			for (int k = 0; k < IPVERSION - 1; k++) {	// read IP network's octets 1-by-1
				rtn = fscanf(stream, "%d.", &tmp);
				keyToVRIM[j].key[k] = tmp;
			}

			rtn = fscanf(stream, "%d/", &tmp);	// read IP network's last octet
			keyToVRIM[j].key[IPVERSION - 1] = tmp;
			rtn = fscanf(stream, "%d", &tmp);	// read IP network mask
			keyToVRIM[j].key[IPVERSION] = tmp;
		}

		fclose(stream);	// close file & create VR w/ mapping
		lvrm->createVRInstanceMonitor(keyToVRIM, keyCount, argv[i]);
	}

	while (1) {	// main while loop  - transceives one network frame to and from LVRM forever each time
		lvrm->transceive();
	}

	return 0;	// on success
}
